package com.hi.music.player.adapter;

import android.graphics.drawable.Drawable;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.recyclerview.widget.RecyclerView;

import com.bumptech.glide.Glide;
import com.bumptech.glide.load.DataSource;
import com.bumptech.glide.load.engine.GlideException;
import com.bumptech.glide.load.resource.bitmap.RoundedCorners;
import com.bumptech.glide.request.RequestListener;
import com.bumptech.glide.request.RequestOptions;
import com.bumptech.glide.request.target.Target;
import com.hi.music.player.MusicApplication;
import com.hi.music.player.R;
import com.hi.music.player.databinding.ItemSingerBinding;
import com.hi.music.player.helper.CommonUtils;
import com.hi.music.player.javabean.response.child.ResponseSingle;

public class AdapterSinger extends BaseAdapter<ResponseSingle, ItemSingerBinding> {

    @Override
    protected ItemSingerBinding getViewBinding(ViewGroup parent) {
        return ItemSingerBinding.inflate(LayoutInflater.from(parent.getContext()), parent, false);
    }

    @Override
    public void onBindViewHolder(@NonNull RecyclerView.ViewHolder holder, int position) {
        int itemViewType = getItemViewType(position);
        if (itemViewType == TYPE_ITEM) {
            VHolder<ItemSingerBinding> itemHolder = (VHolder<ItemSingerBinding>) holder;
            ItemSingerBinding vb = itemHolder.getVb();
            ResponseSingle responseSingle = data.get(position);

            Glide.with(MusicApplication.myApplication)
                    .asDrawable()
                    .load(responseSingle.getSingerHead())
                    .apply(RequestOptions.bitmapTransform(new RoundedCorners(CommonUtils.dpToPx(4))))
                    .placeholder(R.mipmap.ic_launcher)
                    .listener(new RequestListener<Drawable>() {
                        @Override
                        public boolean onLoadFailed(@Nullable GlideException e, @Nullable Object model, @NonNull Target<Drawable> target, boolean isFirstResource) {
                            CommonUtils.LogMsg(e.getMessage());
                            return false;
                        }

                        @Override
                        public boolean onResourceReady(@NonNull Drawable resource, @NonNull Object model, Target<Drawable> target, @NonNull DataSource dataSource, boolean isFirstResource) {
                            return false;
                        }
                    })
                    .into(vb.header);
            vb.tvSingerName.setText(responseSingle.getSingerName());
            vb.tvSongName.setText(responseSingle.getSongTitle());
//        vb.tvDescribe.setText(responseSingle.getDescription());
            vb.getRoot().setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    if (singleClickSingerListener != null) {
                        singleClickSingerListener.onClickSingerItem(responseSingle);
                    }

                }
            });

        }


    }


}
